install 11 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402
  1. #!/bin/bash
  2. #################################################################
  3. # auto-mediawiki #
  4. # Instala un servidor LAMP (Linux+Apache+MySQL+PHP) e instala #
  5. # MediaWiki y lo configura. #
  6. # #
  7. # Guzman Castanedo Villalba (guzman@castanedo.es) Junio 2018 #
  8. # GPLv3 (https://www.gnu.org/licenses/gpl.html) #
  9. #################################################################
  10. OSInfo() {
  11. #printf "Detectando SO..."
  12. debianOS=false
  13. rhelOS=false
  14. OS=$(uname -s)
  15. if [ $OS = "Linux" ]; then
  16. OS="GNU/Linux"
  17. if [ -f /etc/os-release ]; then
  18. DIST=$(grep ^NAME= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  19. REV=$(grep ^VERSION= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  20. ID_LIKE=$(grep ^ID_LIKE= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  21. for i in $ID_LIKE; do
  22. #printf "$i\n"
  23. case $i in
  24. debian|ubuntu)
  25. debianOS=true
  26. break
  27. ;;
  28. rhel|fedora)
  29. rhelOS=true
  30. break
  31. ;;
  32. *)
  33. debianOS=false
  34. rhelOS=false
  35. ;;
  36. esac
  37. done
  38. elif [ -f /etc/debian-version ]; then
  39. # Familia Debian (Debian, Ubuntu, Linux Mint, ...)
  40. DIST="Debian"
  41. REV=""
  42. ID_LIKE="debian"
  43. debianOS=true
  44. elif [ -f /etc/redhat-release ]; then
  45. # Familia Red-Hat (RHEL, Fedora, CentOS, ...)
  46. DIST="Red-Hat"
  47. REV=""
  48. ID_LIKE="rhel"
  49. rhelOS=true
  50. else
  51. # Other Linux (No Soportado)
  52. DIST=""
  53. REV=""
  54. ID_LIKE=""
  55. fi
  56. else
  57. # UNIX, OS X, ... (No Soportado)
  58. DIST=$OS
  59. REV=""
  60. fi
  61. #printf " $DIST $REV\n"
  62. HDInfo=$(df -h | head -1)"\n"$(df -h | grep ^/dev/sd)"\n"$(df -h | grep ^/dev/mapper)
  63. }
  64. comprobarRoot() {
  65. if [ $(id -u) -ne 0 ]; then
  66. printf "ERROR:\tEs necesario ser root ('sudo $0').\n"
  67. exit 1
  68. fi
  69. }
  70. comprobarDependencias() {
  71. # Comprobamos whiptail
  72. which whiptail > /dev/null 2>&1
  73. if [ $? -ne 0 ];then
  74. printf "ERROR:\t'whiptail' no disponible.\n"
  75. exit 1
  76. fi
  77. # Comprobamos hostnamectl
  78. which hostnamectl > /dev/null 2>&1
  79. if [ $? -ne 0 ];then
  80. printf "ERROR:\t'hostnamectl' no disponible.\n"
  81. exit 1
  82. fi
  83. if [ $debianOS = true ];then
  84. # Comprobamos apt-get
  85. which apt-get > /dev/null 2>&1
  86. if [ $? -ne 0 ]; then
  87. printf "ERROR:\t'apt-get' no está disponible.\n"
  88. exit 1
  89. fi
  90. # Actualizamos base de datos del repositorio
  91. printf "Actualizando repositorio APT..."
  92. result=$(apt-get -q -y update)
  93. if [ $? -ne 0 ]; then
  94. printf "\nERROR:\tImposible actualizar repositorio.\n"
  95. printf "Detalles:\n$result\n"
  96. exit 1
  97. fi
  98. printf " OK.\n"
  99. # Comprobamos Firewall (ufw)
  100. which ufw > /dev/null 2>&1
  101. if [ $? -ne 0 ]; then
  102. printf "ERROR:\t'ufw' no disponible.\n"
  103. exit 1
  104. fi
  105. fi
  106. if [ $rhelOS = true ]; then
  107. # Comprobamos yum
  108. which yum > /dev/null 2>&1
  109. if [ $? -ne 0 ]; then
  110. printf "ERROR:\t'yum' no está disponible.\n"
  111. exit 1
  112. fi
  113. # Actualizamos base de datos del repositorio
  114. printf "Actualizando repositorio YUM..."
  115. result=$(yum -y makecache 2>&1)
  116. if [ $? -ne 0 ]; then
  117. printf "\nERROR:\tImposible actualizar repositorio.\n"
  118. printf "Detalles:\n$result\n"
  119. exit 1
  120. fi
  121. printf " OK.\n"
  122. # Comprobamos Firewall (firewall-cmd)
  123. which firewall-cmd > /dev/null 2>&1
  124. if [ $? -ne 0 ]; then
  125. printf "ERROR:\t'firewall-cmd' no disponible.\n"
  126. exit 1
  127. fi
  128. fi
  129. }
  130. comprobarHostname() {
  131. while [ -z $hostname ]; do
  132. hostname=$(whiptail --title "Hostname" --inputbox "El nombre de dominio de este servidor es:\n"$(hostname)"\n\nQuieres cambiarlo por otro?" --ok-button "Cambiar" --cancel-button "No Cambiar" 20 70 3>&1 1>&2 2>&3)
  133. if [ $? -eq 0 ] && [ ! -z $hostname ]; then
  134. hostnamectl set-hostname $hostname
  135. else
  136. hostname=$(hostname)
  137. fi
  138. done
  139. #printf "\nHostname: $hostname\n"
  140. }
  141. mostrarBienvenida() {
  142. if [ $debianOS = false ] && [ $rhelOS = false ]; then
  143. whiptail --title "ERROR OS NO SOPORTADO" --msgbox "Este script automatiza la creación de una web MediaWiki SOLO para distribuciones Linux de la familia Debian (Ubuntu, Linux Mint, ...) y de la familia Red-Hat (CentOS, Fedora, ...).\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" --ok-button "Salir" 20 70
  144. exit 1
  145. fi
  146. whiptail --title "Instalación MediaWiki" --yesno "Este script automatiza completamente la instalación de una wiki.\nPara ello instala un servidor LAMP, el software MediaWiki y lo configura todo.\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" --yes-button "Continuar" --no-button "Salir" 20 70
  147. if [ $? -ne 0 ]; then
  148. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  149. exit 2
  150. fi
  151. }
  152. mostrarComponentes() {
  153. componentes=$(whiptail --title "Instalación" --checklist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge los componentes que quieres instalar:" 20 70 6 \
  154. "WebServer" "Instalar servidor web http/https" ON \
  155. "Database" "Instalar una base de datos SQL" ON \
  156. "PHP" "Instala PHP7" ON \
  157. "SSL/TLS" "Instalar certificados para activar HTTPS" ON \
  158. "MediaWiki" "Instalar wiki con MediaWiki" ON \
  159. "Moodle" "Instalar campus virtual con Moodle" ON \
  160. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  161. if [ $? -ne 0 ]; then
  162. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  163. exit 2
  164. fi
  165. # Mejora: autodetección de componentes ya instalados
  166. for i in $componentes; do
  167. case $i in
  168. \"WebServer\")
  169. printf "Instalando Servidor Web"
  170. instalarWebServer
  171. printf " OK.\n"
  172. ;;
  173. \"Database\")
  174. printf "Instalando Servidor Database"
  175. instalarDatabase
  176. printf " OK.\n"
  177. ;;
  178. \"PHP\")
  179. printf "Instalando PHP..."
  180. printf " OK.\n"
  181. ;;
  182. \"SSL/TLS\")
  183. printf "Instalando SSL/TLS..."
  184. printf " OK.\n"
  185. ;;
  186. \"MediaWiki\")
  187. printf "Instalando MediaWiki..."
  188. printf " OK.\n"
  189. ;;
  190. \"Moodle\")
  191. printf "Instalando Moodle..."
  192. printf " OK.\n"
  193. ;;
  194. *)
  195. printf "ERROR:\tError interno (selección de componentes).\n"
  196. exit 1
  197. ;;
  198. esac
  199. done
  200. }
  201. instalarWebServer() {
  202. webServer=$(whiptail --title "Servidor Web" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge el servidor web que quieres usar:" 20 70 2 \
  203. "Apache" "Instalar el servidor web Apache2" ON \
  204. "Nginx" "Instalar el servidor web Nginx" OFF \
  205. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  206. if [ $? -ne 0 ]; then
  207. printf "\nERROR:\tInstalación interrumpida por el usuario.\n"
  208. exit 2
  209. fi
  210. # Preguntar otras opciones de configuración
  211. comprobarHostname
  212. case $webServer in
  213. Apache)
  214. printf " Apache..."
  215. instalarApache
  216. ;;
  217. Nginx)
  218. printf " Nginx..."
  219. instalarNginx
  220. ;;
  221. *)
  222. printf "\nERROR:\tError interno (selección de web server).\n"
  223. exit 1
  224. ;;
  225. esac
  226. }
  227. instalarApache() {
  228. if [ $debianOS = true ];then
  229. result=$(apt-get -q -y install apache2 2>&1)
  230. if [ $? -ne 0 ]; then
  231. printf "\nERROR:\tError al instalar apache2.\n"
  232. printf "Detalles:\n$result\n"
  233. exit 1
  234. fi
  235. elif [ $rhelOS = true ]; then
  236. result=$(yum -y install httpd 2>&1)
  237. if [ $? -ne 0 ]; then
  238. printf "\nERROR:\tError al instalar apache2.\n"
  239. printf "Detalles:\n$result\n"
  240. exit 1
  241. fi
  242. else
  243. printf "\nERROR:\tError interno (instalación apache).\n"
  244. exit 1
  245. fi
  246. }
  247. instalarNginx() {
  248. if [ $debianOS = true ];then
  249. result=$(apt-get -q -y install nginx 2>&1)
  250. if [ $? -ne 0 ]; then
  251. printf "\nERROR:\tError al instalar apache2.\n"
  252. printf "Detalles:\n$result\n"
  253. exit 1
  254. fi
  255. elif [ $rhelOS = true ]; then
  256. # Hay que instalar primero otro repositorio
  257. result=$(yum -y install nginx 2>&1)
  258. if [ $? -ne 0 ]; then
  259. printf "\nERROR:\tError al instalar apache2.\n"
  260. printf "Detalles:\n$result\n"
  261. exit 1
  262. fi
  263. else
  264. printf "\nERROR:\tError interno (instalación apache).\n"
  265. exit 1
  266. fi
  267. }
  268. instalarDatabase() {
  269. if [ $debianOS = true ]; then
  270. database=$(whiptail --title "Base de Datos" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge la base de datos que quieres usar:" 20 70 2 \
  271. "MySQL" "Instalar la base de datos MySQL (no uso comercial)" ON \
  272. "MariaDB" "Instalar la base de datos MariaDB (fork de MySQL)" OFF \
  273. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  274. if [ $? -ne 0 ]; then
  275. printf "\nERROR:\tInstalación interrumpida por el usuario.\n"
  276. exit 2
  277. fi
  278. # Preguntar otras opciones de configuración
  279. case $database in
  280. MySQL)
  281. printf " MySQL..."
  282. instalarMySQL
  283. ;;
  284. MariaDB)
  285. printf " MariaDB..."
  286. instalarMariaDB
  287. ;;
  288. *)
  289. printf "\nERROR:\tError interno (selección de base de datos).\n"
  290. exit 1
  291. ;;
  292. esac
  293. elif [ $rhelOS = true ]; then
  294. whiptail --title "Base de Datos" --yesno "Para su distribucion $OS $DIST $REV, sólo está disponible la base de datos MariaDB." --yes-button "Continuar" --no-button "Salir" 20 70
  295. if [ $? -ne 0 ]; then
  296. printf "\nERROR:\tInstalación interrumpida por el usuario.\n"
  297. exit 2
  298. fi
  299. printf " MariaDB.."
  300. instalarMariaDB
  301. else
  302. printf "\nERROR:\tError interno (instalación Base de Datos).\n"
  303. exit 1
  304. fi
  305. }
  306. instalarMySQL() {
  307. if [ $debianOS = true ];then
  308. result=$(apt-get -q -y install mysql-server mysql-client 2>&1)
  309. if [ $? -ne 0 ]; then
  310. printf "\nERROR:\tError al instalar MySQL.\n"
  311. printf "Detalles:\n$result\n"
  312. exit 1
  313. fi
  314. elif [ $rhelOS = true ]; then
  315. # MySQL no disponible en RHEL. 2 opciones:
  316. # 1) Instalar un repositorio adicional
  317. # 2) No instalar MySQL en distribuciones RHEL
  318. printf "\nERROR:\tRHEL no incluye MySQL en sus repositorios.\n"
  319. exit 1
  320. else
  321. printf "\nERROR:\tError interno (instalación MySQL).\n"
  322. exit 1
  323. fi
  324. }
  325. instalarMariaDB() {
  326. if [ $debianOS = true ];then
  327. result=$(apt-get -q -y install mariadb-server mariadb-client 2>&1)
  328. if [ $? -ne 0 ]; then
  329. printf "\nERROR:\tError al instalar MariaDB.\n"
  330. printf "Detalles:\n$result\n"
  331. exit 1
  332. fi
  333. elif [ $rhelOS = true ]; then
  334. result=$(yum -y install mariadb-server 2>&1)
  335. if [ $? -ne 0 ]; then
  336. printf "\nERROR:\tError al instalar MariaDB.\n"
  337. printf "Detalles:\n$result\n"
  338. exit 1
  339. fi
  340. else
  341. printf "\nERROR:\tError interno (instalación MariaDB).\n"
  342. exit 1
  343. fi
  344. }
  345. # Comprobamos
  346. comprobarRoot
  347. OSInfo
  348. comprobarDependencias
  349. # Bienvenida
  350. mostrarBienvenida
  351. # Mejora: instalación express vs instalación avanzada
  352. # Selección de componentes
  353. mostrarComponentes
  354. # Pre-configuración
  355. # Habilitar cortafuegos -> PROBLEMA: se corta la conexión ssh
  356. # Instalación
  357. # Cuando funcionen todos los instaladores, cambiarlo por variables de estado e instalar en este punto
  358. # whiptail --gauge
  359. # Configuración
  360. # Configuración Apache
  361. # Virtual Hosts
  362. # Configuración Database
  363. # Configuración Segura
  364. # Configuración PHP
  365. # cgi.fix_pathinfo=0
  366. # Configurar máximo de subida de archivos
  367. # Configuración MediWiki
  368. # Configuración Moodle
  369. # Arrancar y habilitar todos los servicios (SystemD, Service o SystemV)
  370. # Añadir reglas del cortafuegos
  371. # Configuración SSL/TLS
  372. # Generar certificados
  373. # Configurar certificados
  374. # Autodestrucción
  375. {
  376. for i in $(seq 0 5 50); do
  377. sleep 0.1
  378. echo $i
  379. done
  380. } | whiptail --gauge "Autodestrucción..." 7 70 0
  381. {
  382. for i in $(seq 50 5 100); do
  383. sleep 0.1
  384. echo $i
  385. done
  386. } | whiptail --gauge "Autopulverización..." 7 70 50